#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <limits.h>
#include <time.h>
#include <signal.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "cmdline.h"

int main(int argc, char *argv[]) 
{
    char * iam = "client main()";
    struct sigaction newAction, oldAction;
    struct gengetopt_args_info args, argsFile;
    char commandLine[LINE_MAX];
    FILE *commandFile = NULL;;
    int counter = 0;
    
    // Call CLI parser.
    if (cmdline_parser (argc, argv, &args) != 0) {
	fprintf(stderr, "%s: Bad args - exit!", iam);
	syslog(LOG_ERR, "%s: Bad args - exit!", iam);
        exit(EXIT_FAILURE) ;
    }

    if (args.command_given) {
        fprintf (stdout, "Everything is fine!\n");		
    }
    if (args.sleep_given) usleep(args.sleep_arg * 1000);
    
    if (args.file_given) { // Reading commands from file
        if ((commandFile = fopen(args.file_arg, "r")) == NULL) {
	    syslog(LOG_ERR, "%s: Cannot open file %s - exit!\n", 
                   iam, args.file_arg);
	    fprintf(stderr, "%s: Cannot open file %s - exit!\n", 
                             iam, args.file_arg);
	    exit (EXIT_FAILURE);
	}	
	while (counter != args.times2run_arg) {
	    if (args.times2run_arg != -1) counter ++;	
		
	    clearerr(commandFile);
	    fseek(commandFile, 0, SEEK_SET);
	 
	    while(!feof(commandFile)) {
	        if(fgets(commandLine, LINE_MAX, commandFile) == NULL)
		    continue;
	        if(commandLine[0] == '#') continue;
	        if((cmdline_parser_string(commandLine, 
                                          &argsFile, argv[0])) != 0) {
                    fprintf(stderr, "%s: Bad args - exit!", iam);
		    syslog(LOG_ERR, "%s: Bad args - exit!", iam);
	            exit(EXIT_FAILURE) ;
	        }
		if(argsFile.command_given) {
		
	          fprintf(stdout, "Everything is fine here as well!\n");
		}
		cmdline_parser_free(&argsFile);
	    } 
	}
	fclose(commandFile);
    }  
    
    // Finalizing...
    cmdline_parser_free (&args);
    //cmdline_parser_free(&argsFile);
    //unlink(clientFIFOPath);
    exit (EXIT_SUCCESS);                     
} // End main().
